#!/bin/bash

CASESTUDY=$PWD

function coqwc2 () {
  # cat $* | grep -v '^Require' | grep -v '^Set' | coqwc | tail -n 1 | awk '{print ($1+$2)}'
  cat $* | coqwc | tail -n 1 | awk '{print ($1+$2)}'
}

function calc () {

  SEMANTICS="DeclarationSyntax.v DeclarationEvaluation.v DeclarationTyping.v"
  SEMANTICSBP="InfrastructureOperations.v"
  THEOREMSTERMS="InfrastructureLemmasTerms.v"
  THEOREMSCONTEXTS="InfrastructureLemmasContext.v"
  THEOREMSMETA="MetaTheory.v MetaTheoryInversion.v MetaTheoryPreservation.v MetaTheoryProgress.v MetaTheoryShift.v MetaTheorySubst.v MetaTheoryTransitivity.v Option.v"
  BP="$SEMANTICSBP $THEOREMSTERMS $THEOREMSCONTEXTS"
  ALL="$SEMANTICS $SEMANTICSBP $THEOREMSMETA $THEOREMSTERMS $THEOREMSCONTEXTS"

  echo "Semantics        " $(coqwc2 $SEMANTICS *.knot 2> /dev/null)
  echo "Semantics BP     " $(coqwc2 $SEMANTICSBP      2> /dev/null)
  echo "Thm Terms        " $(coqwc2 $THEOREMSTERMS    2> /dev/null)
  echo "Thm Context      " $(coqwc2 $THEOREMSCONTEXTS 2> /dev/null)
  echo "Thm Metatheory   " $(coqwc2 $THEOREMSMETA     2> /dev/null)
  BOILERPLATE=$(coqwc2 $BP 2> /dev/null)
  TOTAL=$(coqwc2 $ALL *.knot 2> /dev/null)
  echo "BOILERPLATE:      $BOILERPLATE"
  echo "TOTAL:            $TOTAL"
}

function go () {
    for dir in $DIRS
    do
	echo
	cd $CASESTUDY/$dir
	echo "---- $dir ----" | sed -e 's/$/                               /' | cut -c1-30 | tee sloc.txt
	calc | sed -e 's/$/                               /' | cut -c1-30 | tee -a sloc.txt
    done
}

DIRS="manual/stlc needle/stlc manual/f needle/f manual/fsub needle/fsub manual/lomega needle/lomega manual/fomega needle/fomega manual/stlcprod needle/stlcprod manual/fprod needle/fprod manual/fsubprod needle/fsubprod manual/fsubrcd needle/fsubrcd manual/fseqlet needle/fseqlet"

function slocs () {
    for dir in $DIRS
    do
	echo -n $CASESTUDY/$dir/sloc.txt " "
    done
}

function pa () {
    while (( "$#" )); do
        paste $1 $2
        echo ""
        shift
        shift
    done
}

go
pa $(slocs) | sed -e 's/ *$//' > $CASESTUDY/sloc.txt
